#include <stdio.h>
#include "sv2_api.h"

test_sv2_ser() {
   char *name = "test_sv2_ser";
   double time = 10.0;
   static double x[] = { 0.0, 1.0, 2.0, 3.0, 4.0 };
   static double fx[] = { 1.0, 2.0, 3.0, 4.0, 5.0 };
   sv2_ser(name, time, x, fx, 5);
}

test_sv2_mser() {      
   char *name = "test_sv2_mser";
   int nt = 2;
   static double time[] = { 1.0, 2.0 };
   static double x[] = { 0.0, 1.0, 2.0, 3.0, 4.0,
                         0.0, 1.0, 2.0, 3.0, 4.00009 };
   static double fx[] = { 1.0, 2.0, 3.0, 4.0, 5.0,
                          5.0, 4.0, 3.0, 2.0, 2.0, };
   static int nx[] = { 5, 5 };
   sv2_mser(name, nt, time, x, fx, nx);
}

test_sv2_bbser() {
   char *name = "test_sv2_bbser";
   double time = 10.0;
   static double bb[] = { 0.0, 2.0 };
   static double fx[] = { 1.0, 2.0, 3.0};
   sv2_bbser(name, time, bb, 3, fx);
}

test_sv2_bbmser() {
   char *name = "test_sv2_bbmser";
   static double time[] = { 1.0,  2.0 };
   static double bb[][4] = { 0.0, 2.0, 0.0, 2.0 };
   static int nx[] = { 3, 3 };
   static double fx[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 1.0 };
   sv2_bbmser(name, 2, time, bb, nx, fx);
}

test_sv2_bbser2d() {
   char *name = "test sv2_bbser2d";
   double time = 10.0;
   static double bb[] = { 0.0, 1.0, 0.0, 2.0 };
   static double fxy[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 1.0 };
   sv2_bbser2d(name, time, bb, 2, 3, fxy);
   
}

test_sv2_bbmser2d() {
   char *name = "test bbmser2d";
   static double time[] = { 1.0,  2.0 };
   static double bb[][4] = { 0.0, 1.0, 0.0, 2.0, 0.0, 1.0, 0.0, 2.0 };
   static int nx[] = { 2, 3 };
   static int ny[] = { 3, 3 };
   static double fxy[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 1.0,
        1.0, 2.0, 3.0, 4.0, 5.0, 1.0, 1.0, 2.0, 3.0  };
   sv2_bbmser2d(name, 2, time, bb, nx, ny, fxy);
}


test_sv2_sercon() {
   char *name = "test_sv2_sercon";
   double time = 10;
   double time2 = 20;
   
   static double x[] = { 2.5, 4.0, 2.0, 0.0, 2.0, 5.0, 
                         7.0, 8.0, 6.0, 8.0, 8.0, 6.0 };
   static double y[] = { 0.0, 2.0, 4.0, 3.0, 2.0, 2.0, 
                         1.0, 2.0, 3.0, 3.0, 5.0, 5.0 };
   static double c[] = { 0.0, 2.0, 4.0, 3.0, 2.0, 5.0, 
                         6.0, 3.0, 1.0, 2.0, 3.0, 4.0 };
   static int cl[] = { 1, 2, 3, 4, 5, -1, 6, 7, 8, -1, 9, 10, 11, 12, -1 };

   static double x2[] = { 1.0, 4.0, 5.0, 6.0, 8.0, 7.0, 5.0, 3.0, 2.0, 1.0 };
   static double y2[] = { 7.0, 5.0, 6.0, 3.0, 8.0, 0.0, 1.0, 0.0, 3.0, 4.0 };
   static int cl2[] = { 1, 2, 3, 4, 5, 6, 7, 8,  9, 10, -1 };

   sv2_sercon(name, time, x, y, c, 12, cl, 15);
   sv2_sercon(name, time2, x2, y2, y2, 10, cl2, 11);
}


main() {
  
   test_sv2_ser(); 
   sleep(2);
   test_sv2_mser(); 
   sleep(2);
   test_sv2_bbser();
   sleep(2);
   test_sv2_bbmser();
   sleep(2);
   test_sv2_bbser2d();
   sleep(2);
   test_sv2_bbmser2d();
   sleep(2);
  test_sv2_sercon();
}
